=== debian/changelog ===
pcl (1.9.1+dfsg1-3ubuntu1) disco; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - reduce parallelism on arm64 and ppc64el

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 21 Dec 2018 15:49:26 +0100

pcl (1.9.1+dfsg1-2ubuntu1) disco; urgency=medium

  * Reduce parallelism on arm64 too

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 19 Dec 2018 23:18:34 +0100
